VERSION 5.00
Begin VB.UserControl DragList 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   ToolboxBitmap   =   "DragList.ctx":0000
   Begin VB.ListBox List1 
      Height          =   2985
      IntegralHeight  =   0   'False
      Left            =   450
      TabIndex        =   0
      Top             =   300
      Width           =   3675
   End
End
Attribute VB_Name = "DragList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'drg DragList
'
'(c) 1999 Joe Hart
'
'This is a subclassed listbox control that allows dragging 'items from one location to another
'
'Thanks to Eduardo Morcillo (E-Mail: edanmo@geocities.com) for providing 'the program
'of which this control is based.
'
'You MAY use this control in your own projects. Be sure to also include the 'mDragList.bas
'file that accompanies this module.
'
'If you compile this contol into an OCX, please RENAME IT before you distribute it
'due to version compatibilty issues.
'
'If you make modifications to this draglist, please send them to me at bghost@ti.cz
'
'This is the main file for the Draglist.  The mDraglist Module is also needed.

Option Explicit
'private types
Private Type POINTAPI 'coordinates
    X As Long
    Y As Long
End Type

Private Type DRAGLISTINFO 'info for draglist
    uNotification As Long
    hWnd As Long
    ptCursor As POINTAPI
End Type

'public enums
Public Enum EdrgAppearance
   drgFlat = 0
   drgThreeD = 1
End Enum

Public Enum EdrgMousePointers
   drgDefault = 0
   drgArrow = 1
   drgCross = 2
   drgIBeam = 3
   drgSize = 5
   drgSizeNESW = 6
   drgSizeNS = 7
   drgSizeNWSE = 8
   drgSizeWE = 9
   drgUpArrow = 10
   drgHourGlass = 11
   drgNoDrop = 12
   drgArrowHourglass = 13
   drgArrowQuestionMark = 14
   drgSizeAll = 15
End Enum

Public Enum EdrgTabStops
   drgEvenSpacedTabs = 1
   drgCustomTabs = 2
End Enum

'private variables
Private m_SubhWnd As Long 'the hWnd of this control when subclassed
Private m_font As StdFont 'the font for the listbox
Private m_DragBackColor As OLE_COLOR 'the color of the drag background
Private m_sBlankItem As String 'blank item added to end to allow dragging to end positon
Private m_DL_Message As Long 'the draglist messages
Private m_PrevProc As Long 'the original Windows Procedure
Private m_Hwnd As Long
 

'Windows API Declares
Private Declare Function MakeDragList Lib "comctl32" (ByVal hLB As Long) As Boolean
Private Declare Function RegisterWindowMessage Lib "user32" Alias "RegisterWindowMessageA" (ByVal lpString As String) As Long
Private Declare Sub DrawInsert Lib "comctl32" (ByVal handParent As Long, ByVal hLB As Long, ByVal nItem As Long)
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function LBItemFromPt Lib "comctl32" (ByVal hLB As Long, ByVal X As Long, ByVal Y As Long, ByVal bAutoScroll As Boolean) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" (Dest As Any, Src As Any, ByVal L As Long)

'Windows API Constants
Private Const DRAGLISTMSGSTRING = "commctrl_DragListMsg"
Private Const LB_SETTABSTOPS As Long = &H192&
Private Const GWL_WNDPROC = (-4)
Private Const GWL_USERDATA = (-21)

Private Const WM_USER = &H400
Private Const DL_BEGINDRAG = (WM_USER + 133)
Private Const DL_DRAGGING = (WM_USER + 134)
Private Const DL_DROPPED = (WM_USER + 135)
Private Const DL_CANCELDRAG = (WM_USER + 136)
Private Const LB_ADDSTRING = 384
Private Const LB_DELETESTRING = 386
Private Const LB_GETCOUNT = 395

'events
Public Event ItemDragBegin(Item As Long)
Public Event ItemDragEnd(FromIndex As Long, ToIndex As Long)
Public Event ItemDragging(ToIndex As Long)
Public Event ItemDragCanceled()
Public Event Click()
Public Event DblClick(Item As Long)
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event KeyPress(KeyAscii As Integer)
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Public Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event Scroll()
Public Event Validate(Cancel As Boolean)

'****************************************************************************
'
'Begin Draglist
'
'****************************************************************************
'
'Delegated properties, methods and events
'
'****************************************************************************
'
'Properties
'
'****************************************************************************

Public Property Get Appearance() As EdrgAppearance
   Appearance = List1.Appearance
End Property

Public Property Let Appearance(NewAppearance As EdrgAppearance)
   List1.Appearance = NewAppearance
   PropertyChanged "Appearance"
End Property

Public Property Get BackColor() As OLE_COLOR
   BackColor = List1.BackColor
End Property

Public Property Let BackColor(NewColor As OLE_COLOR)
   List1.BackColor = NewColor
   PropertyChanged "BackColor"
End Property

Public Property Get Enabled() As Boolean
   Enabled = List1.Enabled
End Property

Public Property Let Enabled(IsEnabled As Boolean)
   List1.Enabled = IsEnabled
   PropertyChanged "Enabled"
End Property

Public Property Get Font() As StdFont
   Set Font = List1.Font
End Property

Public Property Set Font(NewFont As StdFont)
   Set List1.Font = NewFont
   PropertyChanged "Font"
End Property

Public Property Get ForeColor() As OLE_COLOR
   ForeColor = List1.ForeColor
End Property

Public Property Let ForeColor(NewColor As OLE_COLOR)
   List1.ForeColor = NewColor
   PropertyChanged "ForeColor"
End Property
'
Public Property Get ItemData(Index As Integer) As Long
   ItemData = List1.ItemData(Index)
End Property

Public Property Let ItemData(Index As Integer, ByVal NewData As Long)
   List1.ItemData(Index) = NewData
   PropertyChanged "ItemData"
End Property

Public Property Get List(Index As Integer) As String
   List = List1.List(Index)
End Property

Public Property Let List(Index As Integer, Contents As String)
   List1.List(Index) = Contents
   PropertyChanged "List"
End Property

Public Property Get ListCount() As Integer
   ListCount = List1.ListCount
End Property

Public Property Get ListIndex() As Integer
   ListIndex = List1.ListIndex
End Property

Public Property Let ListIndex(NewIndex As Integer)
   List1.ListIndex = NewIndex
End Property

Public Property Get MousePointer() As EdrgMousePointers
   MousePointer = List1.MousePointer
End Property

Public Property Let MousePointer(NewPointer As EdrgMousePointers)
   List1.MousePointer = NewPointer
End Property

Public Property Get Selected(Item As Integer) As Boolean
   Selected = List1.Selected(Item)
End Property

Public Property Let Selected(Item As Integer, IsSelected As Boolean)
   List1.Selected(Item) = IsSelected
End Property

'****************************************************************************
'
'Methods
'
'****************************************************************************
Public Sub AddItem(NewItem As String)
   List1.AddItem NewItem
End Sub

Public Sub RemoveItem(Index As Integer)
   List1.RemoveItem Index
End Sub

Public Sub Clear()
   List1.Clear
End Sub

Public Sub SetFocus()
   List1.SetFocus
End Sub

Public Sub Refresh()
   List1.Refresh
End Sub

'****************************************************************************
'
'Events
'
'****************************************************************************

Private Sub List1_Click()
   RaiseEvent Click
End Sub

Private Sub List1_DblClick()
   RaiseEvent DblClick(List1.ListIndex)
End Sub

Private Sub List1_KeyDown(KeyCode As Integer, Shift As Integer)
   RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub List1_KeyPress(KeyAscii As Integer)
   RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub List1_KeyUp(KeyCode As Integer, Shift As Integer)
   RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub List1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
   RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub List1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
   RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub List1_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
   RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

Private Sub List1_Scroll()
   RaiseEvent Scroll
End Sub
Private Sub List1_Validate(Cancel As Boolean)
   RaiseEvent Validate(Cancel)
End Sub

'****************************************************************************
'
' Properties, Methods and events unique to this control
' (Not found in a normal listbox)
'
'****************************************************************************
Public Property Get Contents() As Variant
   Dim i As Integer
   Dim aStr() As String
   ReDim aStr(List1.ListCount - 1)
   For i = 0 To List1.ListCount - 1
      aStr(i) = List1.List(i)
   Next i
   Contents = aStr()
End Property

Public Property Let Contents(NewContents As Variant)
   Dim v As Variant
   List1.Clear
   For Each v In NewContents
      List1.AddItem v
   Next
End Property

Public Property Get DragBackColor() As OLE_COLOR
   DragBackColor = m_DragBackColor
End Property

Public Property Let DragBackColor(NewColor As OLE_COLOR)
   m_DragBackColor = NewColor
End Property

Public Sub SetTabStops(TabStop As EdrgTabStops, Value As Variant)
   Dim TabStops() As Long
   Dim NumTabs As Long
   Dim i As Integer
   On Error GoTo TabError
   If TabStop = drgCustomTabs Then
      NumTabs = UBound(Value)
      ReDim TabStops(NumTabs)
      For i = 0 To NumTabs
         TabStops(i) = Value(i)
      Next i
   Else
      NumTabs = 9
      ReDim TabStops(9)
      For i = 0 To 9
         TabStops(i) = Value + (Value * i)
      Next i
   End If
   SendMessage List1.hWnd, LB_SETTABSTOPS, NumTabs + 1, TabStops(0)
   Refresh
   Exit Sub
TabError:
   Err.Raise 1002, , "Error Setting TabStop in drg DragList"
End Sub


'****************************************************************************
'
'Private methods internal to the draglist control
'
'****************************************************************************

Private Sub UserControl_AmbientChanged(PropertyName As String)
   'if they changed the name of the control, update the list with the new name
   If PropertyName = "DisplayName" Then
      List1.Clear
      List1.AddItem UserControl.Ambient.DisplayName
   End If
End Sub

Private Sub UserControl_GotFocus()
   List1.SetFocus
End Sub

Private Sub UserControl_Initialize()
   'initialize the control.
   Set m_font = New StdFont
   With m_font
      .Name = "MS Sans Serif"
      .Bold = False
      .Italic = False
      .Size = 8
      .Strikethrough = False
      .Underline = False
   End With
   m_sBlankItem = " "
   m_DragBackColor = &H8000000F
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
   With List1
      .Appearance = PropBag.ReadProperty("Appearance", 1)
      .BackColor = PropBag.ReadProperty("BackColor", &H0)
      m_DragBackColor = PropBag.ReadProperty("DragBackColor", &H8000000F)
      .Enabled = PropBag.ReadProperty("Enabled", True)
      .Font = PropBag.ReadProperty("Font", m_font)
      .ForeColor = PropBag.ReadProperty("ForeColor", &HFFFFFF)
      .MousePointer = PropBag.ReadProperty("MousePointer", 0)
   End With
   StartSubclass
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
   With List1
      PropBag.WriteProperty "Appearance", .Appearance, 1
      PropBag.WriteProperty "BackColor", .BackColor, &HFFFFFF
      PropBag.WriteProperty "DragBackColor", m_DragBackColor, &H8000000F
      PropBag.WriteProperty "Enabled", .Enabled, True
      PropBag.WriteProperty "Font", .Font, m_font
      PropBag.WriteProperty "ForeColor", .ForeColor, &H0
      PropBag.WriteProperty "MousePointer", .MousePointer, 0
   End With
   Call PropBag.WriteProperty("hWnd", UserControl.hWnd, 0)
End Sub

Private Sub UserControl_Resize()
   On Error Resume Next
   'set the size of the list (leave room for the arrow)
   List1.Top = 0
   List1.Left = 200
   List1.Height = ScaleHeight
   List1.Width = ScaleWidth - 200
End Sub

Private Sub UserControl_Terminate()
   EndSubclass
End Sub

Private Sub ResetScreen()
   UserControl.BackColor = UserControl.Ambient.BackColor
   Cls
End Sub

Private Sub LBMoveTo(ToIdx As Long)
'moves an item from the current place to new place

Dim Data As Long
Dim Caption As String
Dim idx As Integer
   
   With List1
      'get current place
      idx = .ListIndex
      'just to be sure....
      If idx >= 0 And ToIdx >= 0 Then
         'get the info from this item
         Data = .ItemData(idx)
         Caption = .List(idx)
         'copy it to new place
         .AddItem Caption, ToIdx
         .ItemData(.NewIndex) = Data
         'set the index to new place
         .ListIndex = ToIdx
         'remove the item from the old place
         '(keep in mind that if the destination
         'is lower than the source that the
         'index is now 1 higher for the old item
         'because the item was INSERTED at the new
         'place
         If ToIdx < idx Then
            .RemoveItem idx + 1
         Else
            .RemoveItem idx
         End If
      End If
   End With
End Sub

Friend Function WinProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   'replacement windows procedure
   Static DragIdx As Long
   Dim ToIdx As Long
   Dim ord As Long 'ignored variable
   Dim LastItemIdx As Long 'index of last item
   Dim DLI As DRAGLISTINFO 'Drag List Info
   If uMsg = m_DL_Message Then 'the message we are looking for
      MoveMemory DLI, ByVal lParam, Len(DLI) 'move the memory from the pointer to our UDT
      Select Case DLI.uNotification 'now, which draglist message?
      Case DL_BEGINDRAG 'start dragging
         'add the blank item to the end
         ord = SendMessage(DLI.hWnd, LB_ADDSTRING, 0&, ByVal StrPtr(m_sBlankItem))
         'get which item we're dragging
         DragIdx = LBItemFromPt(DLI.hWnd, DLI.ptCursor.X, DLI.ptCursor.Y, False)
         'ok, let the control know the drag started
         ResetScreen
         RaiseEvent ItemDragBegin(DragIdx)
         'set the return value
         WinProc = 1
      Case DL_CANCELDRAG 'cancel drag
         'let the control know the drag was cancelled
         ResetScreen
         RaiseEvent ItemDragCanceled
         'set the return value
         WinProc = 2
      Case DL_DRAGGING 'currently dragging
         'let the control know the drag is in progress, and which item they are on now
         UserControl.BackColor = m_DragBackColor
         ToIdx = LBItemFromPt(DLI.hWnd, DLI.ptCursor.X, DLI.ptCursor.Y, True)
         DrawInsert UserControl.hWnd, List1.hWnd, ToIdx
         RaiseEvent ItemDragging(ToIdx)
         WinProc = 3
      Case DL_DROPPED 'drag finished
         'if the item is in a different place than it started then
         ResetScreen
         If LBItemFromPt(DLI.hWnd, DLI.ptCursor.X, DLI.ptCursor.Y, True) <> DragIdx Then
            ToIdx = LBItemFromPt(DLI.hWnd, DLI.ptCursor.X, DLI.ptCursor.Y, True)
            LBMoveTo ToIdx
            'get the count of the listbox
            LastItemIdx = SendMessage(DLI.hWnd, LB_GETCOUNT, 0&, 0&)
            'and tell it to delete the last item
            ord = SendMessage(DLI.hWnd, LB_DELETESTRING, LastItemIdx - 1, ByVal 0&)
            'now send the event
            RaiseEvent ItemDragEnd(DragIdx, ToIdx)
            'set the return value
            WinProc = 4
         End If
      End Select
      'now, we delete the item that we added, but only if the return code
      'warrants it - this is just a safety measure, as it should have already
      'beed deleted.
      If WinProc < 1 Or WinProc > 4 Then
         'get the count of the listbox
         LastItemIdx = SendMessage(DLI.hWnd, LB_GETCOUNT, 0&, 0&)
         'and tell it to delete the last item
         ord = SendMessage(DLI.hWnd, LB_DELETESTRING, LastItemIdx - 1, ByVal 0&)
      End If
      'and exit
      Exit Function
   Else
      'not one of the draglist messages, pass it along to the regular Winproc
      WinProc = CallWindowProc(m_PrevProc, hWnd, uMsg, wParam, lParam)
   End If
End Function

Private Sub StartSubclass()
   'subclass the list only if in run mode
   If UserControl.Ambient.UserMode = True Then
      'register the draglist message
      m_DL_Message = RegisterWindowMessage(DRAGLISTMSGSTRING)
      'turn it into a draglist
      MakeDragList List1.hWnd
      'and start subclassing it
      m_PrevProc = SetWindowLong(UserControl.hWnd, GWL_WNDPROC, AddressOf SubWinProc)
      Call SetWindowLong(UserControl.hWnd, GWL_USERDATA, ObjPtr(Me))
      m_SubhWnd = UserControl.hWnd
   Else
      'since we're in design mode, put the name of the control in the list
      List1.AddItem UserControl.Ambient.DisplayName
   End If
End Sub

Private Sub EndSubclass()
   'if the control is subclassed then
   If m_SubhWnd <> 0 Then
      'stop subclassing it
      SetWindowLong m_SubhWnd, GWL_WNDPROC, m_PrevProc
      m_SubhWnd = 0
   End If
End Sub

Public Property Get hWnd() As Long
   hWnd = UserControl.hWnd
End Property

Public Property Let hWnd(ByVal New_hWnd As Long)
   If Ambient.UserMode = False Then Err.Raise 387
   If Ambient.UserMode Then Err.Raise 382
   m_Hwnd = New_hWnd
   PropertyChanged "hWnd"
End Property

